// Sample Project for 2329RSK
// Johann Gysin
//
// 17.10.2003  Johann Gysin  First Version
// 21.10.2003  Johann Gysin  Added support for LCD-Display

#include "ioh82329.h"
#include "lcd.h"

#define enable_irqs()  asm("andc #0x3F,ccr") // I-Bit im CCR lschen
#define disable_irqs() asm("orc #0xC0,ccr")  // I-Bit im CCR setzen

// Global Variables
unsigned int timer_tick = 0;       
unsigned int timer_sec = 0;

void TimerTick() __attribute__((interrupt_handler));
void TimerTick(void)
  {
  timer_tick++;
  
  // 1000ms    
  if (timer_tick  == 1350)
    {
    timer_tick = 1;
    timer_sec++;
    P2DR = timer_sec;
    LCD_WriteInt(2, 5, timer_sec);
    }
    
  _TCSR0 = _TCSR0 & ~B6; // Clear Compare Match Flag
  }

int main (void)
  {
  // Display Init
  LCD_Init(4);
  LCD_WriteStr(1, 1, "Hello World");
    
  // Counter Init
  MSTPCR = MSTPCR & ~B12;  // Start 8-Bit Timer
  _TCORA0 = 1;             // 1/(Phi/8192)*2 = 1/(22.1184MHz/8192)*2 = 740.74us (Timer for Timer-Tick)
  _TCR0 = B6+B3+B1+B0;     // CMFA Interrupt enabled, Clear @ Compare Match A, Internal Clock Phi/8192
    
  P2DDR = 255;             // Port2 as Output
    
  enable_irqs();
    
  while (1)
    {
    // Your program....    
    }
  }

